package ch.zhaw.pm2.multichat.client;

import javafx.application.Application;
import javafx.fxml.FXMLLoader;
import javafx.scene.Scene;
import javafx.scene.layout.Pane;
import javafx.stage.Stage;

public class ClientUI extends Application {
    private ClientMessageList clientMessageList = new ClientMessageList();
    private ClientConnectionHandler connectionHandler = new ClientConnectionHandler(clientMessageList);

    @Override
    public void start(Stage primaryStage) {
        chatWindow(primaryStage);
    }

    private void chatWindow(Stage primaryStage) {
        try {
            FXMLLoader loader = new FXMLLoader(getClass().getResource("ChatWindow.fxml"));
            Pane rootPane = loader.load();

            ChatWindowController chatWindowController = loader.getController();
            chatWindowController.setMessages(clientMessageList);
            chatWindowController.setConnectionHandler(connectionHandler);

            // fill in scene and stage setup
            Scene scene = new Scene(rootPane);
            //scene.getStylesheets().add(getClass().getResource("application.css").toExternalForm());

            // configure and show stage
            primaryStage.setScene(scene);
            primaryStage.setMinHeight(250);
            primaryStage.setTitle("Multichat Client");
            primaryStage.show();
            primaryStage.setMinWidth(primaryStage.getWidth()); //use automatically computed size as Minimum Size.
        } catch(Exception e) {
            System.err.println("Error starting up UI" + e.getMessage());
        }
    }
}
